Index: cpukit/rtems/src/msgmp.c
===================================================================
--- cpukit/rtems/src/msgmp.c	(revision 17f744b8c81be98f68d53a82583c9a0b1c690579)
+++ cpukit/rtems/src/msgmp.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -1,63 +1,28 @@
-/* SPDX-License-Identifier: BSD-2-Clause */
-
-/**
- * @file
- *
- * @ingroup RTEMSImplClassicMessageMP
- *
- * @brief This source file contains the implementation to support the Message
- *   Manager in multiprocessing (MP) configurations.
- */
-
 /*
- *  COPYRIGHT (c) 1989-2008.
+ *  Multiprocessing Support for the Message Queue Manager
+ *
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
  *  On-Line Applications Research Corporation (OAR).
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
- * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
-
-#ifdef HAVE_CONFIG_H
-#include "config.h"
-#endif
-
-#include <rtems/rtems/messageimpl.h>
-#include <rtems/rtems/optionsimpl.h>
-#include <rtems/rtems/statusimpl.h>
-#include <rtems/score/coremsgimpl.h>
-#include <rtems/score/statesimpl.h>
-#include <rtems/score/threadimpl.h>
-#include <rtems/sysinit.h>
-
-RTEMS_STATIC_ASSERT(
-  MESSAGE_QUEUE_MP_PACKET_SIZE <= MP_PACKET_MINIMUM_PACKET_SIZE,
-  Message_queue_MP_Packet
-);
-
-static Message_queue_MP_Packet *_Message_queue_MP_Get_packet( void )
-{
-  return (Message_queue_MP_Packet *) _MPCI_Get_packet();
-}
-
-
-/*
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/message.h>
+#include <rtems/mpci.h>
+#include <rtems/msgmp.h>
+#include <rtems/object.h>
+#include <rtems/options.h>
+#include <rtems/thread.h>
+#include <rtems/watchdog.h>
+
+/*PAGE
+ *
  *  _Message_queue_MP_Send_process_packet
  *
@@ -67,10 +32,10 @@
   Message_queue_MP_Remote_operations  operation,
   Objects_Id                          message_queue_id,
-  rtems_name                          name,
+  Objects_Name                        name,
   Objects_Id                          proxy_id
 )
 {
   Message_queue_MP_Packet *the_packet;
-  uint32_t                 node;
+  unsigned32               node;
 
   switch ( operation ) {
@@ -81,7 +46,7 @@
 
       the_packet                    = _Message_queue_MP_Get_packet();
-      the_packet->Prefix.the_class  = MP_PACKET_MESSAGE_QUEUE;
-      the_packet->Prefix.length     = MESSAGE_QUEUE_MP_PACKET_SIZE;
-      the_packet->Prefix.to_convert = MESSAGE_QUEUE_MP_PACKET_SIZE;
+      the_packet->Prefix.the_class  = RTEMS_MP_PACKET_MESSAGE_QUEUE;
+      the_packet->Prefix.length     = sizeof ( Message_queue_MP_Packet );
+      the_packet->Prefix.to_convert = sizeof ( Message_queue_MP_Packet );
       the_packet->operation         = operation;
       the_packet->Prefix.id         = message_queue_id;
@@ -90,5 +55,5 @@
 
       if ( operation == MESSAGE_QUEUE_MP_EXTRACT_PROXY )
-         node = _Objects_Get_node( message_queue_id );
+         node = rtems_get_node( message_queue_id );
       else
          node = MPCI_ALL_NODES;
@@ -107,6 +72,4 @@
     case MESSAGE_QUEUE_MP_FLUSH_REQUEST:
     case MESSAGE_QUEUE_MP_FLUSH_RESPONSE:
-    case MESSAGE_QUEUE_MP_GET_NUMBER_PENDING_REQUEST:
-    case MESSAGE_QUEUE_MP_GET_NUMBER_PENDING_RESPONSE:
       break;
 
@@ -114,101 +77,50 @@
 }
 
-/*
+/*PAGE
+ *
  *  _Message_queue_MP_Send_request_packet
  *
  */
 
-static rtems_status_code _Message_queue_MP_Send_request_packet (
+rtems_status_code _Message_queue_MP_Send_request_packet (
+  Message_queue_MP_Remote_operations  operation,
   Objects_Id                          message_queue_id,
-  const void                         *buffer,
-  size_t                             *size_p,
-  rtems_option                        option_set,
-  rtems_interval                      timeout,
-  Message_queue_MP_Remote_operations  operation
+  Message_queue_Buffer               *buffer,
+  rtems_option                     option_set,
+  rtems_interval                   timeout
 )
 {
   Message_queue_MP_Packet *the_packet;
-  Status_Control           status;
-
-  if ( !_Message_queue_MP_Is_remote( message_queue_id ) ) {
-    return RTEMS_INVALID_ID;
-  }
 
   switch ( operation ) {
 
+    case MESSAGE_QUEUE_MP_RECEIVE_REQUEST:
     case MESSAGE_QUEUE_MP_SEND_REQUEST:
     case MESSAGE_QUEUE_MP_URGENT_REQUEST:
     case MESSAGE_QUEUE_MP_BROADCAST_REQUEST:
     case MESSAGE_QUEUE_MP_FLUSH_REQUEST:
-    case MESSAGE_QUEUE_MP_GET_NUMBER_PENDING_REQUEST:
 
       the_packet                    = _Message_queue_MP_Get_packet();
-      the_packet->Prefix.the_class  = MP_PACKET_MESSAGE_QUEUE;
-      the_packet->Prefix.length     = MESSAGE_QUEUE_MP_PACKET_SIZE;
-      if ( size_p )
-        the_packet->Prefix.length     += *size_p;
-      the_packet->Prefix.to_convert = MESSAGE_QUEUE_MP_PACKET_SIZE;
-
-      /*
-       * make sure message is not too big for our MPCI driver
-       * We have to check it here instead of waiting for MPCI because
-       * we are about to slam in the payload
-       */
-
-      if (the_packet->Prefix.length > _MPCI_table->maximum_packet_size) {
-          return RTEMS_INVALID_SIZE;
-      }
-
-      if (! _Options_Is_no_wait(option_set))
+      the_packet->Prefix.the_class  = RTEMS_MP_PACKET_MESSAGE_QUEUE;
+      the_packet->Prefix.length     = sizeof ( Message_queue_MP_Packet );
+      the_packet->Prefix.to_convert = sizeof ( Message_queue_MP_Packet ) -
+                         sizeof ( Message_queue_Buffer );
+      if ( ! _Options_Is_no_wait(option_set))
           the_packet->Prefix.timeout = timeout;
 
-      the_packet->operation  = operation;
-      the_packet->Prefix.id  = message_queue_id;
-      the_packet->option_set = option_set;
-
-      /*
-       * Copy the data into place if needed
-       */
-
-      if (buffer) {
-          the_packet->size = *size_p;
-          _CORE_message_queue_Copy_buffer(
-            buffer,
-            the_packet->buffer,
-            *size_p
-          );
-      }
-
-      status = _MPCI_Send_request_packet(
-        _Objects_Get_node(message_queue_id),
-        &the_packet->Prefix,
-        STATES_WAITING_FOR_MESSAGE
-      );
-      return _Status_Get( status );
-
-    case MESSAGE_QUEUE_MP_RECEIVE_REQUEST:
-
-      the_packet                    = _Message_queue_MP_Get_packet();
-      the_packet->Prefix.the_class  = MP_PACKET_MESSAGE_QUEUE;
-      the_packet->Prefix.length     = MESSAGE_QUEUE_MP_PACKET_SIZE;
-      the_packet->Prefix.to_convert = MESSAGE_QUEUE_MP_PACKET_SIZE;
-
-      if (! _Options_Is_no_wait(option_set))
-          the_packet->Prefix.timeout = timeout;
-
-      the_packet->operation  = MESSAGE_QUEUE_MP_RECEIVE_REQUEST;
-      the_packet->Prefix.id  = message_queue_id;
-      the_packet->option_set = option_set;
-      the_packet->size       = 0;        /* just in case of an error */
-
-      _Thread_Executing->Wait.return_argument_second.immutable_object = buffer;
-      _Thread_Executing->Wait.return_argument = size_p;
-
-      status = _MPCI_Send_request_packet(
-        _Objects_Get_node(message_queue_id),
-        &the_packet->Prefix,
-        STATES_WAITING_FOR_MESSAGE
-      );
-      return _Status_Get( status );
+      the_packet->operation         = operation;
+      the_packet->Prefix.id         = message_queue_id;
+      the_packet->option_set        = option_set;
+
+      if ( buffer )
+        _Message_queue_Copy_buffer( buffer, &the_packet->Buffer );
+
+      return
+        _MPCI_Send_request_packet(
+          rtems_get_node( message_queue_id ),
+          &the_packet->Prefix,
+          STATES_WAITING_FOR_MESSAGE
+        );
+      break;
 
     case MESSAGE_QUEUE_MP_ANNOUNCE_CREATE:
@@ -220,117 +132,21 @@
     case MESSAGE_QUEUE_MP_BROADCAST_RESPONSE:
     case MESSAGE_QUEUE_MP_FLUSH_RESPONSE:
-    case MESSAGE_QUEUE_MP_GET_NUMBER_PENDING_RESPONSE:
-      break;
+      break;
+
   }
-
+  /*
+   *  The following line is included to satisfy compilers which
+   *  produce warnings when a function does not end with a return.
+   */
   return RTEMS_SUCCESSFUL;
 }
 
-rtems_status_code _Message_queue_MP_Broadcast(
-  rtems_id    id,
-  const void *buffer,
-  size_t      size,
-  uint32_t   *count
-)
-{
-  _Thread_Get_executing()->Wait.return_argument = count;
-  return _Message_queue_MP_Send_request_packet(
-    id,
-    buffer,
-    &size,
-    0,
-    MPCI_DEFAULT_TIMEOUT,
-    MESSAGE_QUEUE_MP_BROADCAST_REQUEST
-  );
-}
-
-rtems_status_code _Message_queue_MP_Flush(
-  rtems_id  id,
-  uint32_t *count
-)
-{
-  _Thread_Get_executing()->Wait.return_argument = count;
-  return _Message_queue_MP_Send_request_packet(
-    id,
-    NULL,
-    NULL,
-    0,
-    MPCI_DEFAULT_TIMEOUT,
-    MESSAGE_QUEUE_MP_FLUSH_REQUEST
-  );
-}
-
-rtems_status_code _Message_queue_MP_Get_number_pending(
-  rtems_id  id,
-  uint32_t *count
-)
-{
-  _Thread_Get_executing()->Wait.return_argument = count;
-  return _Message_queue_MP_Send_request_packet(
-    id,
-    NULL,
-    NULL,
-    0,
-    MPCI_DEFAULT_TIMEOUT,
-    MESSAGE_QUEUE_MP_GET_NUMBER_PENDING_REQUEST
-  );
-}
-
-rtems_status_code _Message_queue_MP_Receive(
-  rtems_id        id,
-  void           *buffer,
-  size_t         *size,
-  rtems_option    option_set,
-  rtems_interval  timeout
-)
-{
-  return _Message_queue_MP_Send_request_packet(
-    id,
-    buffer,
-    size,
-    option_set,
-    timeout,
-    MESSAGE_QUEUE_MP_RECEIVE_REQUEST
-  );
-}
-
-rtems_status_code _Message_queue_MP_Send(
-  rtems_id    id,
-  const void *buffer,
-  size_t      size
-)
-{
-  return _Message_queue_MP_Send_request_packet(
-    id,
-    buffer,
-    &size,
-    0,
-    MPCI_DEFAULT_TIMEOUT,
-    MESSAGE_QUEUE_MP_SEND_REQUEST
-  );
-}
-
-rtems_status_code _Message_queue_MP_Urgent(
-  rtems_id    id,
-  const void *buffer,
-  size_t      size
-)
-{
-  return _Message_queue_MP_Send_request_packet(
-    id,
-    buffer,
-    &size,
-    0,
-    MPCI_DEFAULT_TIMEOUT,
-    MESSAGE_QUEUE_MP_URGENT_REQUEST
-  );
-}
-
-/*
+/*PAGE
+ *
  *  _Message_queue_MP_Send_response_packet
  *
  */
 
-static void _Message_queue_MP_Send_response_packet (
+void _Message_queue_MP_Send_response_packet (
   Message_queue_MP_Remote_operations  operation,
   Objects_Id                          message_queue_id,
@@ -347,5 +163,4 @@
     case MESSAGE_QUEUE_MP_BROADCAST_RESPONSE:
     case MESSAGE_QUEUE_MP_FLUSH_RESPONSE:
-    case MESSAGE_QUEUE_MP_GET_NUMBER_PENDING_RESPONSE:
 
       the_packet = ( Message_queue_MP_Packet *) the_thread->receive_packet;
@@ -354,16 +169,10 @@
  *  The packet being returned already contains the class, length, and
  *  to_convert fields, therefore they are not set in this routine.
- *
- *  Exception: MESSAGE_QUEUE_MP_RECEIVE_RESPONSE needs payload length
- *             added to 'length'
  */
       the_packet->operation = operation;
       the_packet->Prefix.id = the_packet->Prefix.source_tid;
 
-      if (operation == MESSAGE_QUEUE_MP_RECEIVE_RESPONSE)
-          the_packet->Prefix.length += the_packet->size;
-
       _MPCI_Send_response_packet(
-        _Objects_Get_node( the_packet->Prefix.source_tid ),
+        rtems_get_node( the_packet->Prefix.source_tid ),
         &the_packet->Prefix
       );
@@ -378,5 +187,4 @@
     case MESSAGE_QUEUE_MP_BROADCAST_REQUEST:
     case MESSAGE_QUEUE_MP_FLUSH_REQUEST:
-    case MESSAGE_QUEUE_MP_GET_NUMBER_PENDING_REQUEST:
       break;
 
@@ -384,5 +192,12 @@
 }
 
-static void _Message_queue_MP_Process_packet (
+/*PAGE
+ *
+ *
+ *  _Message_queue_MP_Process_packet
+ *
+ */
+
+void _Message_queue_MP_Process_packet (
   rtems_packet_prefix   *the_packet_prefix
 )
@@ -390,4 +205,5 @@
   Message_queue_MP_Packet *the_packet;
   Thread_Control          *the_thread;
+  boolean                  ignored;
 
   the_packet = (Message_queue_MP_Packet *) the_packet_prefix;
@@ -397,10 +213,10 @@
     case MESSAGE_QUEUE_MP_ANNOUNCE_CREATE:
 
-      _Objects_MP_Allocate_and_open(
-        &_Message_queue_Information,
-        the_packet->name,
-        the_packet->Prefix.id,
-        true
-      );
+      ignored = _Objects_MP_Open(
+                  &_Message_queue_Information,
+                  the_packet->name,
+                  the_packet->Prefix.id,
+                  TRUE
+                );
 
       _MPCI_Return_packet( the_packet_prefix );
@@ -418,7 +234,6 @@
       the_thread = _Thread_MP_Find_proxy( the_packet->proxy_id );
 
-      if ( the_thread != NULL ) {
-        _Thread_queue_Extract( the_thread );
-      }
+      if ( ! _Thread_Is_null( the_thread ) )
+         _Thread_queue_Extract( the_thread->Wait.queue, the_thread );
 
       _MPCI_Return_packet( the_packet_prefix );
@@ -429,11 +244,10 @@
       the_packet->Prefix.return_code = rtems_message_queue_receive(
         the_packet->Prefix.id,
-        the_packet->buffer,
-        &the_packet->size,
+        &the_packet->Buffer,
         the_packet->option_set,
         the_packet->Prefix.timeout
       );
 
-      if ( the_packet->Prefix.return_code != RTEMS_PROXY_BLOCKING )
+      if ( ! _Status_Is_proxy_blocking( the_packet->Prefix.return_code ) )
         _Message_queue_MP_Send_response_packet(
           MESSAGE_QUEUE_MP_RECEIVE_RESPONSE,
@@ -447,14 +261,8 @@
       the_thread = _MPCI_Process_response( the_packet_prefix );
 
-      if (the_packet->Prefix.return_code == RTEMS_SUCCESSFUL) {
-        *(size_t *) the_thread->Wait.return_argument =
-           the_packet->size;
-
-        _CORE_message_queue_Copy_buffer(
-          the_packet->buffer,
-          the_thread->Wait.return_argument_second.mutable_object,
-          the_packet->size
-        );
-      }
+      _Message_queue_Copy_buffer(
+        &the_packet->Buffer,
+        (Message_queue_Buffer *) the_thread->Wait.return_argument
+      );
 
       _MPCI_Return_packet( the_packet_prefix );
@@ -465,6 +273,5 @@
       the_packet->Prefix.return_code = rtems_message_queue_send(
         the_packet->Prefix.id,
-        the_packet->buffer,
-        the_packet->size
+        &the_packet->Buffer
       );
 
@@ -488,6 +295,5 @@
       the_packet->Prefix.return_code = rtems_message_queue_urgent(
         the_packet->Prefix.id,
-        the_packet->buffer,
-        the_packet->size
+        &the_packet->Buffer
       );
 
@@ -503,6 +309,5 @@
       the_packet->Prefix.return_code = rtems_message_queue_broadcast(
         the_packet->Prefix.id,
-        the_packet->buffer,
-        the_packet->size,
+        &the_packet->Buffer,
         &the_packet->count
       );
@@ -517,9 +322,8 @@
     case MESSAGE_QUEUE_MP_BROADCAST_RESPONSE:
     case MESSAGE_QUEUE_MP_FLUSH_RESPONSE:
-    case MESSAGE_QUEUE_MP_GET_NUMBER_PENDING_RESPONSE:
 
       the_thread = _MPCI_Process_response( the_packet_prefix );
 
-      *(uint32_t *) the_thread->Wait.return_argument = the_packet->count;
+      *(unsigned32 *)the_thread->Wait.return_argument = the_packet->count;
 
       _MPCI_Return_packet( the_packet_prefix );
@@ -540,22 +344,9 @@
       break;
 
-    case MESSAGE_QUEUE_MP_GET_NUMBER_PENDING_REQUEST:
-
-      the_packet->Prefix.return_code = rtems_message_queue_get_number_pending(
-        the_packet->Prefix.id,
-        &the_packet->count
-      );
-
-      _Message_queue_MP_Send_response_packet(
-        MESSAGE_QUEUE_MP_GET_NUMBER_PENDING_RESPONSE,
-        the_packet->Prefix.id,
-        _Thread_Executing
-      );
-      break;
-
   }
 }
 
-/*
+/*PAGE
+ *
  *  _Message_queue_MP_Send_object_was_deleted
  *
@@ -563,6 +354,5 @@
 
 void _Message_queue_MP_Send_object_was_deleted (
-  Thread_Control *the_proxy,
-  Objects_Id      mp_id
+  Thread_Control  *the_proxy
 )
 {
@@ -571,10 +361,11 @@
   _Message_queue_MP_Send_response_packet(
     MESSAGE_QUEUE_MP_RECEIVE_RESPONSE,
-    mp_id,
+    the_proxy->Wait.id,
     the_proxy
   );
 }
 
-/*
+/*PAGE
+ *
  *  _Message_queue_MP_Send_extract_proxy
  *
@@ -582,41 +373,25 @@
 
 void _Message_queue_MP_Send_extract_proxy (
-  Thread_Control *the_thread,
-  Objects_Id      id
+  Thread_Control  *the_thread
 )
 {
   _Message_queue_MP_Send_process_packet(
     MESSAGE_QUEUE_MP_EXTRACT_PROXY,
-    id,
-    (rtems_name) 0,
+    the_thread->Wait.id,
+    (Objects_Name) 0,
     the_thread->Object.id
   );
 }
 
-void  _Message_queue_Core_message_queue_mp_support(
-  Thread_Control *the_thread,
-  Objects_Id      id
-)
-{
-  the_thread->receive_packet->return_code = RTEMS_SUCCESSFUL;
-
-  _Message_queue_MP_Send_response_packet(
-    MESSAGE_QUEUE_MP_RECEIVE_RESPONSE,
-    id,
-    the_thread
-  );
-}
-
-static void _Message_queue_MP_Initialize( void )
-{
-  _MPCI_Register_packet_processor(
-    MP_PACKET_MESSAGE_QUEUE,
-    _Message_queue_MP_Process_packet
-  );
-}
-
-RTEMS_SYSINIT_ITEM(
-  _Message_queue_MP_Initialize,
-  RTEMS_SYSINIT_CLASSIC_MESSAGE_QUEUE_MP,
-  RTEMS_SYSINIT_ORDER_MIDDLE
-);
+/*PAGE
+ *
+ *  _Message_queue_MP_Get_packet
+ *
+ */
+
+Message_queue_MP_Packet *_Message_queue_MP_Get_packet ( void )
+{
+  return ( (Message_queue_MP_Packet *) _MPCI_Get_packet() );
+}
+
+/* end of file */
Index: cpukit/rtems/src/part.c
===================================================================
--- cpukit/rtems/src/part.c	(revision 17f744b8c81be98f68d53a82583c9a0b1c690579)
+++ cpukit/rtems/src/part.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -1,48 +1,322 @@
-/**
- * @file
- *
- * @ingroup RTEMSImplClassicPartition
- *
- * @brief This source file contains a definition of the
- *   ::_Partition_Information with zero objects.
- */
-
 /*
- * SPDX-License-Identifier: BSD-2-Clause
- *
- * Copyright (C) 2018 embedded brains GmbH & Co. KG
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
- * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
-
-#ifdef HAVE_CONFIG_H
-#include "config.h"
-#endif
-
-#include <rtems/rtems/partdata.h>
-
-OBJECTS_INFORMATION_DEFINE_ZERO(
-  _Partition,
-  OBJECTS_CLASSIC_API,
-  OBJECTS_RTEMS_PARTITIONS,
-  OBJECTS_NO_STRING_NAME
-);
+ *  Partition Manager
+ *
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/address.h>
+#include <rtems/config.h>
+#include <rtems/object.h>
+#include <rtems/part.h>
+#include <rtems/thread.h>
+
+/*PAGE
+ *
+ *  _Partition_Manager_initialization
+ *
+ *  This routine initializes all partition manager related
+ *  data structures.
+ *
+ *  Input parameters:
+ *    maximum_partitions - number of partitions to initialize
+ *
+ *  Output parameters:  NONE
+ */
+
+void _Partition_Manager_initialization(
+  unsigned32 maximum_partitions
+)
+{
+  _Objects_Initialize_information(
+    &_Partition_Information,
+    TRUE,
+    maximum_partitions,
+    sizeof( Partition_Control )
+  );
+
+}
+
+/*PAGE
+ *
+ *  rtems_partition_create
+ *
+ *  This directive creates a partiton of fixed sized buffers from the
+ *  given contiguous memory area.
+ *
+ *  Input parameters:
+ *    name             - user defined partition name
+ *    starting_address - physical start address of partition
+ *    length           - physical length in bytes
+ *    buffer_size      - size of buffers in bytes
+ *    attribute_set    - partition attributes
+ *    id               - pointer to partition id
+ *
+ *  Output parameters:
+ *    id                - partition id
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code        - if unsuccessful
+ */
+
+rtems_status_code rtems_partition_create(
+  Objects_Name        name,
+  void               *starting_address,
+  unsigned32          length,
+  unsigned32          buffer_size,
+  rtems_attribute  attribute_set,
+  Objects_Id         *id
+)
+{
+  register Partition_Control *the_partition;
+
+  if ( !_Objects_Is_name_valid( name ) )
+    return ( RTEMS_INVALID_NAME );
+
+  if ( length == 0 || buffer_size == 0 || length < buffer_size ||
+         !_Partition_Is_buffer_size_aligned( buffer_size ) )
+    return ( RTEMS_INVALID_SIZE );
+
+  if ( !_Addresses_Is_aligned( starting_address ) )
+     return( RTEMS_INVALID_ADDRESS );
+
+  if ( _Attributes_Is_global( attribute_set ) &&
+       !_Configuration_Is_multiprocessing() )
+    return( RTEMS_MP_NOT_CONFIGURED );
+
+  _Thread_Disable_dispatch();               /* prevents deletion */
+
+  the_partition = _Partition_Allocate();
+
+  if ( !the_partition ) {
+    _Thread_Enable_dispatch();
+    return( RTEMS_TOO_MANY );
+  }
+
+  if ( _Attributes_Is_global( attribute_set ) &&
+       !( _Objects_MP_Open( &_Partition_Information, name,
+                            the_partition->Object.id, FALSE ) ) ) {
+    _Partition_Free( the_partition );
+    _Thread_Enable_dispatch();
+    return( RTEMS_TOO_MANY );
+  }
+  the_partition->starting_address      = starting_address;
+  the_partition->length                = length;
+  the_partition->buffer_size           = buffer_size;
+  the_partition->attribute_set         = attribute_set;
+  the_partition->number_of_used_blocks = 0;
+
+  _Chain_Initialize( &the_partition->Memory, starting_address,
+                        length / buffer_size, buffer_size );
+
+  _Objects_Open( &_Partition_Information, &the_partition->Object, name );
+
+  *id = the_partition->Object.id;
+  if ( _Attributes_Is_global( attribute_set ) )
+    _Partition_MP_Send_process_packet(
+      PARTITION_MP_ANNOUNCE_CREATE,
+      the_partition->Object.id,
+      name,
+      0                  /* Not used */
+    );
+
+  _Thread_Enable_dispatch();
+  return( RTEMS_SUCCESSFUL );
+}
+
+/*PAGE
+ *
+ *  rtems_partition_ident
+ *
+ *  This directive returns the system ID associated with
+ *  the partition name.
+ *
+ *  Input parameters:
+ *    name - user defined partition name
+ *    node - node(s) to be searched
+ *    id   - pointer to partition id
+ *
+ *  Output parameters:
+ *    *id               - partition id
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code        - if unsuccessful
+ */
+
+rtems_status_code rtems_partition_ident(
+  Objects_Name  name,
+  unsigned32    node,
+  Objects_Id   *id
+)
+{
+  return( _Objects_Name_to_id( &_Partition_Information, name, node, id ) );
+}
+
+/*PAGE
+ *
+ *  rtems_partition_delete
+ *
+ *  This directive allows a thread to delete a partition specified by
+ *  the partition identifier, provided that none of its buffers are
+ *  still allocated.
+ *
+ *  Input parameters:
+ *    id - partition id
+ *
+ *  Output parameters:
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code        - if unsuccessful
+ */
+
+rtems_status_code rtems_partition_delete(
+  Objects_Id id
+)
+{
+  register Partition_Control *the_partition;
+  Objects_Locations                  location;
+
+  the_partition = _Partition_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+      return( RTEMS_INVALID_ID );
+    case OBJECTS_REMOTE:
+      _Thread_Dispatch();
+      return( RTEMS_ILLEGAL_ON_REMOTE_OBJECT );
+    case OBJECTS_LOCAL:
+      if ( the_partition->number_of_used_blocks == 0 ) {
+        _Objects_Close( &_Partition_Information, &the_partition->Object );
+        _Partition_Free( the_partition );
+        if ( _Attributes_Is_global( the_partition->attribute_set ) ) {
+
+          _Objects_MP_Close(
+            &_Partition_Information,
+            the_partition->Object.id
+          );
+
+          _Partition_MP_Send_process_packet(
+            PARTITION_MP_ANNOUNCE_DELETE,
+            the_partition->Object.id,
+            0,                         /* Not used */
+            0                          /* Not used */
+          );
+        }
+
+        _Thread_Enable_dispatch();
+        return( RTEMS_SUCCESSFUL );
+      }
+      _Thread_Enable_dispatch();
+      return( RTEMS_RESOURCE_IN_USE );
+  }
+
+  return( RTEMS_INTERNAL_ERROR );   /* unreached - only to remove warnings */
+}
+
+/*PAGE
+ *
+ *  rtems_partition_get_buffer
+ *
+ *  This directive will obtain a buffer from a buffer partition.
+ *
+ *  Input parameters:
+ *    id     - partition id
+ *    buffer - pointer to buffer address
+ *
+ *  Output parameters:
+ *    buffer            - pointer to buffer address filled in
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code        - if unsuccessful
+ */
+
+rtems_status_code rtems_partition_get_buffer(
+  Objects_Id   id,
+  void       **buffer
+)
+{
+  register Partition_Control *the_partition;
+  Objects_Locations           location;
+  void                       *the_buffer;
+
+  the_partition = _Partition_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+      return( RTEMS_INVALID_ID );
+    case OBJECTS_REMOTE:
+      _Thread_Executing->Wait.return_argument = buffer;
+      return(
+        _Partition_MP_Send_request_packet(
+          PARTITION_MP_GET_BUFFER_REQUEST,
+          id,
+          0           /* Not used */
+        )
+      );
+    case OBJECTS_LOCAL:
+      the_buffer = _Partition_Allocate_buffer( the_partition );
+      if ( the_buffer ) {
+        the_partition->number_of_used_blocks += 1;
+        _Thread_Enable_dispatch();
+        *buffer = the_buffer;
+        return( RTEMS_SUCCESSFUL );
+      }
+      _Thread_Enable_dispatch();
+      return( RTEMS_UNSATISFIED );
+  }
+
+  return( RTEMS_INTERNAL_ERROR );   /* unreached - only to remove warnings */
+}
+
+/*PAGE
+ *
+ *  rtems_partition_return_buffer
+ *
+ *  This directive will return the given buffer to the specified
+ *  buffer partition.
+ *
+ *  Input parameters:
+ *    id     - partition id
+ *    buffer - pointer to buffer address
+ *
+ *  Output parameters:
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code - if unsuccessful
+ */
+
+rtems_status_code rtems_partition_return_buffer(
+  Objects_Id  id,
+  void       *buffer
+)
+{
+  register Partition_Control *the_partition;
+  Objects_Locations           location;
+
+  the_partition = _Partition_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+      return( RTEMS_INVALID_ID );
+    case OBJECTS_REMOTE:
+      return(
+        _Partition_MP_Send_request_packet(
+          PARTITION_MP_RETURN_BUFFER_REQUEST,
+          id,
+          buffer
+        )
+      );
+    case OBJECTS_LOCAL:
+      if ( _Partition_Is_buffer_valid( buffer, the_partition ) ) {
+        _Partition_Free_buffer( the_partition, buffer );
+        the_partition->number_of_used_blocks -= 1;
+        _Thread_Enable_dispatch();
+        return( RTEMS_SUCCESSFUL );
+      }
+      _Thread_Enable_dispatch();
+      return( RTEMS_INVALID_ADDRESS );
+  }
+
+  return( RTEMS_INTERNAL_ERROR );   /* unreached - only to remove warnings */
+}
